#include <stdio.h>
#include <stdarg.h>

void print(const char *str, ...)
{
	if (!str || !*str)
	    return;
	int i;
	double d;
	char c, *s;
	va_list argptr;
	va_start(argptr, str);
	do
		switch(*str)
		{
			case 'i':
				i = va_arg(argptr, int);
				printf("%d", i);
				break;
			case 'd':
				d = va_arg(argptr, double);
				printf("%g", d);
				break;
			case 'c':
				c = va_arg(argptr, int);
				printf("%c", c);
				break;
			case 's':
				s = va_arg(argptr, char *);
				printf("%s", s);
				break;							
		}
	while (*++str);
	va_end(argptr);
}

int main()
{
	print("sicdcd", ": ", 123, '*', 4.56, '=', 123 * 4.56);
	return 0;
}

