#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

typedef union
{
    int i;
    double d;
    char *s;
} result;

result sum(char type, int num, ...)
{
	result res;
	va_list argptr;
	va_start(argptr, num);
	int sum1 = 0;
	double sum2 = 0.0;
	char *str;
	switch (type)
	{
		case 'i':
			for (int i = 0; i < num; i++)
			    sum1 += va_arg(argptr, int);
			va_end(argptr);
			res.i = sum1;
			return res;
		case 'd':
			for (int i = 0; i < num; i++)
			    sum2 += va_arg(argptr, double);
			va_end(argptr);
			res.d = sum2;
			return res;
		case 's':
			for (int i = 0; i < num; i++)
			    sum1 += strlen(va_arg(argptr, char *));
			va_end(argptr);
			str = malloc (sum1 + 1);
			*str = '\0';
			va_start(argptr, num);
			for (int i = 0; i < num; i++)
			    strncat(str, va_arg(argptr, char *), sum1);
			va_end(argptr);
			res.s = str;
			return res;
	}
	res.s = 0;
	return res;
}

int main()
{
	printf("3 + 5 + 8 - 6 = %d\n", sum('i', 4, 3, 5, 8, -6).i);
	printf("1.2 + 3.4 + 5.6 - 7.8 - 9.1 = %g\n", sum('d', 5, 1.2, 3.4, 5.6, -7.8, -9.1).d);
	char *str;
	printf("\"\" + \" \" + \"\" + \"!\" = \"%s\"",
		   str = sum('s', 4, "", " ", "", "!").s); 
	free(str);
	return 0;
}

